// ==UserScript==
// @name         huabei
// @namespace    http://tampermonkey.net/
// @version      0.1
// @description  try to take over the world!
// @author       You
// @match        https://*.alipay.com/*
// @require    http://code.jquery.com/jquery-2.2.4.js
// @grant        none

// ==/UserScript==
jQuery.ajaxSetup({
    async : false
});

// 花呗、支付宝公用字段
var acctName; // 账号信息，唯一匹配字段，用以跨域信息关联
var userName; // 用户名： “某某某”
var logonIdType;
var type;
var interval = 500;  // ajax請求停留時間
var cardNo;
var ipw = ""; //验证码
var canceled = false;

// 支付宝接口相关字段
var zfbPageNo = 1; // 賬單當前頁
var zfbTotalPage = 1; // 賬單總頁數
var zfbTempPage = 1;  // 用於計算賬單是否分頁完成
var zfbBills = [];  // 支付宝账单数组
var zfbInterval;   // 支付宝轮询变量
var initZfb = true;  // 进入第一页爬取标签
var zfbBalance;  // 支付宝余额
var zfbData; // 支付宝将要返回给APP的JSON串

// 花呗接口相关字段
var currentPage = 0;
var totalPage =0;
var hbUrl = "https://f.alipay.com/moonlight/index.htm";
var isHBPageLoaded = false;
var hbRepayAmount;
var hbBalance;
var hbAvailable;
var hbRepayDate;
var hbBills = [];
var hbRepayRecords = [];
var hbRepayTotalAmount;
var hbData;

jQuery(function() {
    isLogin();
    console.log(isHBPageLoaded);
    var pageHtml=document.documentElement.outerHTML;
    acctName = pageHtml.substring(pageHtml.indexOf("mobile:") + 8, pageHtml.indexOf("mobile:") + 20);

    // 花呗域下
    try{
	    if(isHBPageLoaded){
	    	//正在搜索账单
	        callBackJSCrawlStatus('{"status":"1"}');

	        console.log("开始获取花呗页面信息....");
	        // 获取花呗页面内容：https://f.alipay.com/moonlight/index.htm
	        cardNo = jQuery("#j-btntask").attr("data-cardNo");
	        console.log("card No = " + cardNo + " ,ctoken = " + getCookie("ctoken"));
	        getHBDetails();
	        if(canceled) return;
	        // 发送完花呗详情信息后，跳转至支付宝账单查询页面：https://consumeprod.alipay.com/record/standard.htm
	        window.location.href="https://consumeprod.alipay.com/record/standard.htm";
	    }

	    // 支付宝域下
	    if(window.location.href === "https://consumeprod.alipay.com/record/advanced.htm"){
	        //切换到标准版
	        switchVersion();
	      //正在解析账单
		    callBackJSCrawlStatus('{"status":"2"}');
	    }
	    if(window.location.href === "https://consumeprod.alipay.com/record/standard.htm"){
	    	console.log("开始获取支付宝信息....");
	        zfbBalance = jQuery(".ft-green").text();
	        userName = jQuery("ul.fn-right > li:nth-child(1) > span:nth-child(1)").text();
	    	getZFBDetails();
	    	//解析完成
	        callBackJSCrawlStatus('{"status":"3"}');
	    }
    } catch (e){
    	console.log("看什么看,出错了!\n" + e);
    	callBackJSCrawlStatus('{"status":"4"}');
    }
    if(canceled) return;
});

function switchVersion(){
	var versions = trim(jQuery(".link").text());
     console.log("当前可切换至:" + versions);
	if(versions.indexOf("切换到标准版") > -1) {
        //1.发送切换请求
        jQuery.get("https://consumeprod.alipay.com/record/switchVersion.htm",{},function(data){
            console.log("切换responce : ");
        });
        //2.获取切换后首页
        window.location.href="https://consumeprod.alipay.com/record/standard.htm";
        console.log("已切换到标准版，现在可切换至：");
		console.log(trim(jQuery(data).find(".link").text()));
	}
}

function isLogin(){
	//检测验证码
	checkIpw()

    jQuery.get(hbUrl,{},function(data){
        if(data!== undefined){
            var payAmount =  jQuery(data).find(".tocal-amount");
            if(payAmount)
            {
            	isHBPageLoaded = true;
            } else {
            	//callback 跳转至花呗页面失败
            	callBackJSCrawlStatus('{"status":"9"}');
            }
        }
    });
}

function checkIpw(){
	var ipwEle = jQuery(ipw);
	if(ipwEle !== null && ipwEle !== undefined && ipwEle !== ''){
		//通知弹出验证码
		callBackJSCrawlStatus('{"status":"9"}');
	}
}

function getCookie(name)
{
    if(name === null) return document.cookie;
    var arrstr = document.cookie.split("; ");
    for(var i = 0;i < arrstr.length;i ++){
        var temp = arrstr[i].split("=");
        if(temp[0] == name) return unescape(temp[1]);
    }
}

function getHBDetails(){
    var billTotalPage = 1;
    var payAmount =null;
    var availableAmount =null;
    var totalAmount = null;

    var pageNumArea = jQuery(".ui-paging-bold").text();
    if(pageNumArea.indexOf("/") >　-1) {
    	billTotalPage = pageNumArea.substring(pageNumArea.indexOf("/") + 1);
    }
    console.log("total page num: " + billTotalPage);
    hbRepayAmount = jQuery(".tocal-amount").text();
    hbBalance = jQuery("div.inner:nth-child(1) > p:nth-child(2) > strong:nth-child(1)").text();
    hbAvailable = jQuery("div.inner:nth-child(1) > p:nth-child(3)").text();
    console.log("hbRepayAmount: " + hbRepayAmount + ", hbBalance=" + hbBalance + ", hbAvailable="+hbAvailable);
    hbRepayDate = jQuery(".detail > li:nth-child(2)").html();
    hbRepayDate = replaceAll(hbRepayDate,"&nbsp;","");
    userName = jQuery(".global-top-text").text();

    getRepayPlan();
    getHbBills(billTotalPage);

    if(canceled) return;
    postHbDetail();
}

function replaceAll(ori, exp, rep){
    while (ori.indexOf(exp) >= 0){
        ori = ori.replace(exp, rep);
    }
    return ori;
}

function postHbDetail(){
	hbData = {
	    type : "hb",
	    acctName : acctName,
        userName : userName,
	    hbRepayAmount : hbRepayAmount,
		hbBalance : hbBalance,
		hbAvailable : hbAvailable,
		hbRepayDate : hbRepayDate,
        hbBillLength: hbBills.length,
		hbBills : JSON.stringify(hbBills),
		hbRepayTotalAmount : hbRepayTotalAmount
	};

    console.log("hb data = " + JSON.stringify(hbData));
    callBackJSCrawlData('{"data":' + JSON.stringify(hbData) + '}')
}

function getRepayPlan(){
    console.log("prepare to get repay plan!" + " cardNo=" + cardNo, + ", ctoken=" + getCookie("ctoken"));
    jQuery.ajax({
		// 提交数据的类型 POST GET
		type : "POST",
		// 提交的网址
		url : "https://f.alipay.com/moonlight/repayPlan.json",
		// 提交的数据
		data : {
			billDate:"01",
			_input_charset:"utf-8",
			ctoken: getCookie("ctoken"),
			cardNo: cardNo,
		},
		// 返回数据的格式
		datatype : "json",// "xml", "html", "script", "json", "jsonp", "text".
		// 成功返回之后调用的函数
		success : function(data) {
			console.log("总欠款金额: " + data.allAmount.amount);
			hbRepayTotalAmount = data.allAmount.amount;
		},
		// 调用出错执行的函数
		error : function() {
			console.log("Error happened when download repay plan.");
		}
	});
}

function getHbBills(billTotalPage){
	hbBills.push(jQuery(".ui-table").html());
	if(billTotalPage > 1) {
		for(var i = 2; i<=billTotalPage; i ++){
			if(canceled) return;
			var url = "https://f.alipay.com/moonlight/index.htm?type=&page=" + i + "&totalPage=" + billTotalPage;
			jQuery.get(url,function(data){
				hbBills.push(jQuery(data).find(".ui-table").html());
		    });
		}
	}
}

function getZFBDetails() {
    zfbInterval = self.setInterval(postZFBDetail,interval);
}

function postZFBDetail() {
	if(canceled) {
		self.clearInterval(zfbInterval);
        zfbInterval = null;
        console.log("任务取消!");
        return;
	}
    if(zfbTotalPage === undefined || zfbTotalPage === null || zfbTotalPage === ""){
        self.clearInterval(zfbInterval);
        zfbInterval = null;
        console.log("end loop...");
        sendZFBDetail();
        return;
    }
    if(!initZfb){
         if(zfbTempPage != zfbPageNo) {
             return;
         }
    }

	jQuery.ajax({
		type : "POST",
		url : "https://consumeprod.alipay.com/record/standard.htm",
		data : {
			// ua:"072n+qZ9mgNqgJnCG0Yus65w7XCvsi/yLDVddU=|nOiH84T+h/GG+ob9jvqD/18=|neiHGXz1WexE7V/kge6L/IDliu912WjPfcdxFLQU|mu6b9JEfY9da8EfrQ/92zHrCR+596G73gCasILzIdNx2Ap/nche3|m++T/GIXeA92GW0Veh+sELTescSr3rISjD2F7oThQeE=|mOOM6Yws|meWK74oq|luKW+WcCqR6pGqzRo9F3xXTCespi0WTWcQCkC6cUsAx922nZqx62EKIXsMJ0w2fWcdVgx7Ydqhp/EHUQsBA=|l+GOEGQRYg1+EWUZahxzB38EcB9rF2IRfgp5AnEeahZjEH8LeA983Hw=|lOCT/JkHcgl8BnoViu+b7JbhmOue5pzkkOybJFcmVSxZIlgrXydbI1ggVyBZI1XKr8C0FHHR|leKNE3YTfAVwBmkdaR5qBX4Cdw2tDQ==|kuWKFHEUewF9B2gcahFiDXkKcgRx0XE=|k+SLFXAVeg56A3YZbRpjH3AEdwt9BqYG|kOeIFnMWeQ14DHsUbxhtAnYCeQJ62no=|keaJF3IXeAx/A3sUYhViDXkMcAx11XU=|jvmWCG3gkDaENYM7iyNT9VHmTuRW4186VSFSJlI9SzhEK18pXipd/V0=|j/iXCWzhkSePK544k+NE4Ff/jymbKp05lSSMOVwzTzVGKVwmXTJGP0w3QOBA|jPuUCm/ikiSMKJ07kOBH41T8jCqYKZ46liePOl8wTDZAL1ogWDdCNkE3QeFB|jfqVC24LZB9rF3gPdwRrHmgSax29HQ==|iv2SDGkMYx9pHnEEfwRrHmkdZBy8HA==|i/yTDWgNYhhgFHsNdQBvGmIUbBa2Fg==|iP+QDmsOYRtgFXoNfgRrHmcSbh29HQ==|if6RD2rnlzGDMoQ8jCRU8lbhSeNR5Fg9UiZVIlE+SDtHKF0kXipQ8FA=|hvGeAGUAbxRoE3wLfAZpHGcfZhy8HA==|h/CfAWTpmS+HI5Ywm+tM6F/3hyGTIpUxnSyEMVQ7Rz1KJVAqUT5LMEw2TOxM|hPyTDWjllSKJPJQ8TPxO/0jjhul3C3EEax5nE3wAdw18BGseaR5xCX0SZxCw36zDpg24ELk5lDCJLZs9iCSXIEg+utKkIUQrXS5aL1z8XA==|hf+QDmsOYRV6DH8LfAamBg==|gviXCWzhkSaNOJA4SPhK+0zngu2Z9oDzh/2IKIg=|g/SH9Jvoh/Kd6Z7qhfOL8Z7mmvWP95jsmO+A9Jvnk/yF6pL9iuWT/Inmkv2O4ZHlivqP4JDmifmO4ZHphvaP4JDqhfWO4ZL9iP6R5JEx",
			dateType:"createDate",
			dateRange:"threeMonths",
			beginDate: getRelatedDate(-3),
			endDate: getRelatedDate(0),
			beginTime:"00:00",
			endTime:"24:00",
			tradeType:"ALL",
			status:"all",
			fundFlow:"all",
			pageNum: zfbPageNo,
			rdsToken: form_tk,
            _input_charset: "utf-8",
		    ctoken : getCookie("ctoken")
			// rdsUa:"072n+qZ9mgNqgJnCG0Yus65w7XCvsi/yLDVddU=|nOiH84T+h/GG+ob9jvqD/18=|neiHGXz1WexE7V/kge6L/IDliu912WjPfcdxFLQU|mu6b9JEfY9da8EfrQ/92zHrCR+596G73gCasILzIdNx2Ap/nche3|m++T/GIXeA92GW0Veh+sELTescSr3rISjD2F7oThQeE=|mOOM6Yws|meWK74oq|luKW+WcCqR6pGqzRo9F3xXTCespi0WTWcQCkC6cUsAx922nZqx62EKIXsMJ0w2fWcdVgx7Ydqhp/EHUQsBA=|l+GOEGQRYg1+EWUZahxzB38EcB9rF2IRfgp5AnEeahZjEH8LeA983Hw=|lOCT/JkHcgl8BnoViu+b7JbhmOue5pzkkOybJFcmVSxZIlgrXydbI1ggVyBZI1XKr8C0FHHR|leKNE3YTfAVwBmkdaR5qBX4Cdw2tDQ==|kuWKFHEUewF9B2gcahFiDXkKcgRx0XE=|k+SLFXAVeg56A3YZbRpjH3AEdwt9BqYG|kOeIFnMWeQ14DHsUbxhtAnYCeQJ62no=|keaJF3IXeAx/A3sUYhViDXkMcAx11XU=|jvmWCG3gkDaENYM7iyNT9VHmTuRW4186VSFSJlI9SzhEK18pXipd/V0=|j/iXCWzhkSePK544k+NE4Ff/jymbKp05lSSMOVwzTzVGKVwmXTJGP0w3QOBA|jPuUCm/ikiSMKJ07kOBH41T8jCqYKZ46liePOl8wTDZAL1ogWDdCNkE3QeFB|jfqVC24LZB9rF3gPdwRrHmgSax29HQ==|iv2SDGkMYx9pHnEEfwRrHmkdZBy8HA==|i/yTDWgNYhhgFHsNdQBvGmIUbBa2Fg==|iP+QDmsOYRtgFXoNfgRrHmcSbh29HQ==|if6RD2rnlzGDMoQ8jCRU8lbhSeNR5Fg9UiZVIlE+SDtHKF0kXipQ8FA=|hvGeAGUAbxRoE3wLfAZpHGcfZhy8HA==|h/CfAWTpmS+HI5Ywm+tM6F/3hyGTIpUxnSyEMVQ7Rz1KJVAqUT5LMEw2TOxM|hPyTDWjllSKJPJQ8TPxO/0jjhul3C3EEax5nE3wAdw18BGseaR5xCX0SZxCw36zDpg24ELk5lDCJLZs9iCSXIEg+utKkIUQrXS5aL1z8XA==|hf+QDmsOYRV6DH8LfAamBg==|gviXCWzhkSaNOJA4SPhK+0zngu2Z9oDzh/2IKIg=|g/SH9Jvoh/Kd6Z7qhfOL8Z7mmvWP95jsmO+A9Jvnk/yF6pL9iuWT/Inmkv2O4ZHlivqP4JDmifmO4ZHphvaP4JDqhfWO4ZL9iP6R5JEx"
		},
		datatype : "html",// "xml", "html", "script", "json", "jsonp", "text".
		success : function(data) {
			zfbTotalPage = jQuery(data).find(".page-end.page-trigger").attr("pageNum");
            zfbBills.push(jQuery(data).find("#tradeRecordsIndex").html());
            zfbPageNo ++;
		},
		error : function() {
			console.log("fetch zfb bills error");
		}
	});
    initZfb = false;
    zfbTempPage++;
}

function sendZFBDetail(){
    var i = 1;
    zfbData = {
    	zfbBalance : zfbBalance,
    	type : "zfb",
    	acctName : acctName,
        userName : userName,
        zfbBillLength : zfbBills.length,
        bills : JSON.stringify(zfbBills)
    };
    console.log("zfbData = " + JSON.stringify(zfbData));
    callBackJSCrawlData('{"data":' + JSON.stringify(zfbData) + '}')
}

// 获取【addMonth】个月的日期，格式YYYY.MM.DD
function getRelatedDate(addMonth) {
    var date = new Date();
    var seperator = ".";
    var year = date.getFullYear();
    var month = date.getMonth() + 1;

    if(month + addMonth <= 0){
    	year = year - 1;
    	month = 12 + month + addMonth;
    } else {
    	month = month + addMonth;
    }

    if (month >= 1 && month <= 9) {
        month = "0" + month;
    }

    var strDate = date.getDate();
    if (strDate >= 0 && strDate <= 9) {
        strDate = "0" + strDate;
    }
    var currentdate = year + seperator + month + seperator + strDate;
    return currentdate;
}

function trim(str){ //删除左右两端的空格
　　return str.replace(/(^\s*)|(\s*$)/g, "");
}

function shutDownJSCrawl(){
	canceled = true;
}